// IconPickerList.cpp : implementation file
//

#include "stdafx.h"
#include "ChangeIcon.h"
#include "IconPickerList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIconPickerList

CIconPickerList::CIconPickerList()
{
}

CIconPickerList::~CIconPickerList()
{
}


BEGIN_MESSAGE_MAP(CIconPickerList, CListBox)
	//{{AFX_MSG_MAP(CIconPickerList)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIconPickerList message handlers

void CIconPickerList::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	HICON hIcon = (HICON)lpDrawItemStruct->itemData; // HICON in Item data

	if (lpDrawItemStruct->itemAction & ODA_DRAWENTIRE)
	{
		// Paint the color item in the color requested
//		CBrush br(cr);
//		pDC->FillRect(&lpDrawItemStruct->rcItem, &br);
		pDC->DrawIcon(lpDrawItemStruct->rcItem.left+5,lpDrawItemStruct->rcItem.top+5,hIcon);
	}

	if ((lpDrawItemStruct->itemState & ODS_SELECTED) &&
		(lpDrawItemStruct->itemAction & (ODA_SELECT | ODA_DRAWENTIRE)))
	{
		// item has been selected - hilite frame
		CBrush br(GetSysColor(COLOR_HIGHLIGHT));
		CRect rect;
		rect.CopyRect(&lpDrawItemStruct->rcItem);
		rect.DeflateRect(2,2,2,2);
		pDC->FrameRect(&rect, &br);

		rect.DeflateRect(1,1,1,1);
		pDC->FrameRect(&rect, &br);

	}

	if (!(lpDrawItemStruct->itemState & ODS_SELECTED) &&
		(lpDrawItemStruct->itemAction & ODA_SELECT))
	{
		// Item has been de-selected -- remove frame
		CBrush br(GetSysColor(COLOR_WINDOW));
		CRect rect;
		rect.CopyRect(&lpDrawItemStruct->rcItem);
		rect.DeflateRect(2,2,2,2);
		pDC->FrameRect(&rect, &br);

		rect.DeflateRect(1,1,1,1);
		pDC->FrameRect(&rect, &br);
	}
	
}

void CIconPickerList::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
	lpMeasureItemStruct->itemHeight = 42;
	lpMeasureItemStruct->itemWidth = 42;
}

int CIconPickerList::AddIconItem(HICON hIcon)
{
	return AddString((LPCTSTR) hIcon);
}
